Subject: Re: BCM5719(tg3) use multiple MSI with RSS

From: Mike Qiu <[email-masked]>
Date: Thu, 16 May 2013 10:25:32 +0800

于 2013/5/15 23:52, Ben Hutchings 写道:
> On Wed, 2013-05-15 at 08:08 -0700, Michael Chan wrote:
>> On Wed, 2013-05-15 at 15:56 +0800, Mike Qiu wrote:
>>> Hi all
>>>
>>> Currently, I need to enable multiple MSI on BCM5719 network card.
>>> But I look in to the spec of 5719 from Broadcom, it seems
>>> that RSS just enable with MSI-X, so I'm not sure if multiple
>>> MSI can use RSS.
>>>
>> MSI can only support one IRQ source and cannot support RSS.
> It is possible for an MSI capability to have multiple MSIs, but they
> will use the same address and consecutive data values.
Yes, it should be this.
> On x86, if you can find a large enough block of free IRQs on an IOAPIC,
> it is possible to implement RSS this way.  Linux supports this on
> systems with an x2apic.
But, I see the tg3 spec, and it seems the RSS is just for MSI-X(and IOV).
And I try to enable RSS use multiple MSI for 4 irqs, the system
alloc 4 consecutive irqs to tg3, and each one can be test pass using 
interrupt test.
But the last 3 interrupts seems not to be triggered as "cat /proc/interrups"
shows after the driver loaded. Only the first irq can be triggered for
only sometimes. The network surely not work.
> Now, maybe tg3 hardware doesn't support this (and really, why bother
> when there is MSI-X?) but the option does exist.
Actually, I try to enable the multiple MSI feature, and needs tg3 card to
support this feature. For some old PCI device, it may only support 
multiple MSI

Thanks
Mike
> Ben.